From c32327e107aef99565fd6b652ffb959103777212 Mon Sep 17 00:00:00 2001
From: Rafia Sabih <rafia.sabih@cybertec.at>
Date: Fri, 14 Nov 2025 16:39:12 +0100
Subject: [PATCH] Fetch without cursors

This implements a new fetch mechanism for cursors which does not use cursors.
The motivation behind this work is the limitation of cursors to not be able to use
parallel query even at the local side. Since, this new fetch mode doesn't use cursors
parallel query can now be used and hence improving the performance for postgres_fdw.

The way this new mechanism works is, once we start a query and create a cursor
to fetch the tuples for a query this mechanism just start processing the tuples for
this query without creating any cursor for it.  Next, when we need tuples from a
different query and issue a call to create a new cursor in old method. At this point,
the new mode fetches all the tuples of the first query and saves them in a tuplestore.
Moving forward, the next query is processed as is. Next, whenever we need to fetch the
tuples of the first query, we do so by reading the associated tuplestore where we saved
the tuples earlier. This way we use this tuplestore to keep track of the tuples required
instead of cursors.

This new mode can be used by a new GUC called postgres_fdw.use_cursor.
When it is set, everything works as it was before this patch i.e. with the cursors.

Original idea: Bernd Helmle
Key suggestions: Robert Haas
---
 contrib/postgres_fdw/connection.c             |    6 +
 .../postgres_fdw/expected/postgres_fdw.out    | 4663 ++++++++++++++++-
 contrib/postgres_fdw/option.c                 |   19 +
 contrib/postgres_fdw/postgres_fdw.c           |  541 +-
 contrib/postgres_fdw/postgres_fdw.h           |   26 +
 contrib/postgres_fdw/sql/postgres_fdw.sql     | 1270 ++++-
 6 files changed, 6336 insertions(+), 189 deletions(-)

diff --git a/contrib/postgres_fdw/connection.c b/contrib/postgres_fdw/connection.c
index 953c2e0ab82..f8468e10f92 100644
--- a/contrib/postgres_fdw/connection.c
+++ b/contrib/postgres_fdw/connection.c
@@ -966,6 +966,12 @@ pgfdw_get_result(PGconn *conn)
 	return libpqsrv_get_result_last(conn, pgfdw_we_get_result);
 }
 
+PGresult *
+pgfdw_get_next_result(PGconn *conn)
+{
+	return libpqsrv_get_result(conn, pgfdw_we_get_result);
+}
+
 /*
  * Report an error we got from the remote server.
  *
diff --git a/contrib/postgres_fdw/option.c b/contrib/postgres_fdw/option.c
index 04788b7e8b3..75ca6412728 100644
--- a/contrib/postgres_fdw/option.c
+++ b/contrib/postgres_fdw/option.c
@@ -44,6 +44,7 @@ static PgFdwOption *postgres_fdw_options;
  * GUC parameters
  */
 char	   *pgfdw_application_name = NULL;
+bool		pgfdw_use_cursor = true;
 
 /*
  * Helper functions
@@ -586,5 +587,23 @@ _PG_init(void)
 							   NULL,
 							   NULL);
 
+	/*
+	 * If use_cursor is set to false, then the new way of fetching is used. In
+	 * this mode, cursors are not used, rather the tuples are stored in a
+	 * tupeslot in case the switch of queries in between execution. So, for
+	 * the next call, tuples are fetched from this tuplestore instead of the
+	 * fresh query execution.
+	 */
+	DefineCustomBoolVariable("postgres_fdw.use_cursor",
+							 "If set uses the cursor, otherwise fetches without cursor",
+							 NULL,
+							 &pgfdw_use_cursor,
+							 true,
+							 PGC_USERSET,
+							 0,
+							 NULL,
+							 NULL,
+							 NULL);
+
 	MarkGUCPrefixReserved("postgres_fdw");
 }
diff --git a/contrib/postgres_fdw/postgres_fdw.c b/contrib/postgres_fdw/postgres_fdw.c
index 06b52c65300..b4050beaf92 100644
--- a/contrib/postgres_fdw/postgres_fdw.c
+++ b/contrib/postgres_fdw/postgres_fdw.c
@@ -22,6 +22,7 @@
 #include "commands/explain_format.h"
 #include "commands/explain_state.h"
 #include "executor/execAsync.h"
+#include "executor/executor.h"
 #include "foreign/fdwapi.h"
 #include "funcapi.h"
 #include "miscadmin.h"
@@ -451,7 +452,7 @@ static bool ec_member_matches_foreign(PlannerInfo *root, RelOptInfo *rel,
 									  EquivalenceClass *ec, EquivalenceMember *em,
 									  void *arg);
 static void create_cursor(ForeignScanState *node);
-static void fetch_more_data(ForeignScanState *node);
+static void fetch_more_data(ForeignScanState *node, bool use_tts);
 static void close_cursor(PGconn *conn, unsigned int cursor_number,
 						 PgFdwConnState *conn_state);
 static PgFdwModifyState *create_foreign_modify(EState *estate,
@@ -546,6 +547,11 @@ static void merge_fdw_options(PgFdwRelationInfo *fpinfo,
 							  const PgFdwRelationInfo *fpinfo_i);
 static int	get_batch_size_option(Relation rel);
 
+static void populate_query_state(PrevQueryState * copy_to, PrevQueryState * pqs);
+static void save_prev_query(ForeignScanState *node);
+static void clear_conn_state(PgFdwConnState *conn_state);
+static void clear_prev_query_state(PrevQueryState * pqs);
+static void fillTupleSlot(PgFdwScanState *fsstate, ForeignScanState *node);
 
 /*
  * Foreign-data wrapper handler function: return a struct with pointers
@@ -1593,6 +1599,108 @@ postgresBeginForeignScan(ForeignScanState *node, int eflags)
 
 	/* Set the async-capable flag */
 	fsstate->async_capable = node->ss.ps.async_capable;
+
+	fsstate->conn_state->num_prev_queries = 0;
+	fsstate->conn_state->prev_queries = NULL;
+}
+
+/* Clear the prev_query state */
+static void
+clear_prev_query_state(PrevQueryState * pqs)
+{
+	if (!pqs)
+		return;
+	if (pqs->last_tupdesc && pqs->tuplestore)
+	{
+		/* Release only when the tuplesotre was created */
+		ReleaseTupleDesc(pqs->last_tupdesc);
+		pqs->last_tupdesc = NULL;
+		pqs->tuplestore = NULL;
+		pqs->total_tuples = 0;
+	}
+	pqs = NULL;
+}
+
+/* Clear the conn_state before exiting either becuase of errors or otherwise */
+static void
+clear_conn_state(PgFdwConnState *conn_state)
+{
+	PrevQueryState *p1 = NULL;
+
+	if (!conn_state)
+		return;
+	p1 = conn_state->prev_queries;
+	if (!p1)
+		return;
+	for (; p1 != NULL; p1 = p1->next)
+	{
+		clear_prev_query_state(p1);
+		conn_state->num_prev_queries--;
+	}
+}
+
+/* Fill the Tupleslot when another query needs to execute. */
+static void
+fillTupleSlot(PgFdwScanState *fsstate, ForeignScanState *node)
+{
+	char	   *cur_query = fsstate->query;
+
+	/* const char **values = fsstate->param_values; */
+	int			cur_numParams = fsstate->numParams;
+	Relation	cur_rel = fsstate->rel;
+	TupleDesc	cur_tupdesc = fsstate->tupdesc;
+	AttInMetadata *cur_attinmeta = fsstate->attinmeta;
+	List	   *cur_retrieved_attrs = fsstate->retrieved_attrs;
+	StringInfoData buf;
+	PGconn	   *conn = fsstate->conn;
+	const char **values = fsstate->param_values;
+	PrevQueryState *p1 = fsstate->conn_state->prev_queries;
+
+	initStringInfo(&buf);
+
+	/* Always fetch the last prev_query */
+	for (; p1->next != NULL; p1 = p1->next);
+
+	/*
+	 * Populate the fsstate with the details stored for the last query.
+	 */
+	fsstate->query = p1->last_query;
+	fsstate->rel = p1->last_rel;
+	fsstate->tupdesc = p1->last_tupdesc;
+	fsstate->attinmeta = p1->last_attinmeta;
+	fsstate->retrieved_attrs = p1->last_retrieved_attrs;
+	fsstate->numParams = p1->last_numParams;
+
+	if (conn->asyncStatus == PGASYNC_IDLE)
+	{
+		/* If the connection is not active then set up */
+		appendStringInfo(&buf, "%s", fsstate->query);
+		if (!PQsendQueryParams(conn, buf.data, fsstate->numParams,
+							   NULL, values, NULL, NULL, 0))
+		{
+			clear_conn_state(fsstate->conn_state);
+			pgfdw_report_error(NULL, conn, buf.data);
+		}
+
+		/*
+		 * Call for Chunked rows mode with same size of chunk as the fetch
+		 * size
+		 */
+		if (!PQsetChunkedRowsMode(conn, fsstate->fetch_size))
+		{
+			clear_conn_state(fsstate->conn_state);
+			pgfdw_report_error(NULL, conn, buf.data);
+		}
+	}
+	fetch_more_data(node, true);
+
+	fsstate->query = cur_query;
+	fsstate->tupdesc = cur_tupdesc;
+	fsstate->rel = cur_rel;
+	fsstate->attinmeta = cur_attinmeta;
+	fsstate->retrieved_attrs = cur_retrieved_attrs;
+	fsstate->numParams = cur_numParams;
+	p1->tuples_ready = true;
 }
 
 /*
@@ -1625,7 +1733,8 @@ postgresIterateForeignScan(ForeignScanState *node)
 			return ExecClearTuple(slot);
 		/* No point in another fetch if we already detected EOF, though. */
 		if (!fsstate->eof_reached)
-			fetch_more_data(node);
+			fetch_more_data(node, false);
+
 		/* If we didn't get any tuples, must be end of data. */
 		if (fsstate->next_tuple >= fsstate->num_tuples)
 			return ExecClearTuple(slot);
@@ -1651,6 +1760,7 @@ postgresReScanForeignScan(ForeignScanState *node)
 	PgFdwScanState *fsstate = (PgFdwScanState *) node->fdw_state;
 	char		sql[64];
 	PGresult   *res;
+	bool		close_cursor = false;
 
 	/* If we haven't created the cursor yet, nothing to do. */
 	if (!fsstate->cursor_exists)
@@ -1666,7 +1776,7 @@ postgresReScanForeignScan(ForeignScanState *node)
 	if (fsstate->async_capable &&
 		fsstate->conn_state->pendingAreq &&
 		fsstate->conn_state->pendingAreq->requestee == (PlanState *) node)
-		fetch_more_data(node);
+		fetch_more_data(node, false);
 
 	/*
 	 * If any internal parameters affecting this node have changed, we'd
@@ -1680,19 +1790,26 @@ postgresReScanForeignScan(ForeignScanState *node)
 	if (node->ss.ps.chgParam != NULL)
 	{
 		fsstate->cursor_exists = false;
-		snprintf(sql, sizeof(sql), "CLOSE c%u",
-				 fsstate->cursor_number);
+		if (pgfdw_use_cursor)
+			snprintf(sql, sizeof(sql), "CLOSE c%u",
+					 fsstate->cursor_number);
+		else
+			close_cursor = true;
 	}
 	else if (fsstate->fetch_ct_2 > 1)
 	{
 		if (PQserverVersion(fsstate->conn) < 150000)
+			/* this case not handled for nocursor case */
 			snprintf(sql, sizeof(sql), "MOVE BACKWARD ALL IN c%u",
 					 fsstate->cursor_number);
 		else
 		{
 			fsstate->cursor_exists = false;
-			snprintf(sql, sizeof(sql), "CLOSE c%u",
-					 fsstate->cursor_number);
+			if (pgfdw_use_cursor)
+				snprintf(sql, sizeof(sql), "CLOSE c%u",
+						 fsstate->cursor_number);
+			else
+				close_cursor = true;
 		}
 	}
 	else
@@ -1701,18 +1818,32 @@ postgresReScanForeignScan(ForeignScanState *node)
 		fsstate->next_tuple = 0;
 		return;
 	}
+	if (pgfdw_use_cursor)
+	{
+		res = pgfdw_exec_query(fsstate->conn, sql, fsstate->conn_state);
+		if (PQresultStatus(res) != PGRES_COMMAND_OK)
+			pgfdw_report_error(res, fsstate->conn, sql);
+		PQclear(res);
+		/* Now force a fresh FETCH. */
+		fsstate->tuples = NULL;
+		fsstate->num_tuples = 0;
+		fsstate->next_tuple = 0;
+		fsstate->fetch_ct_2 = 0;
+		fsstate->eof_reached = false;
+	}
+	else if (!pgfdw_use_cursor && close_cursor)
+	{
+		while (pgfdw_get_result(fsstate->conn) != NULL);
 
-	res = pgfdw_exec_query(fsstate->conn, sql, fsstate->conn_state);
-	if (PQresultStatus(res) != PGRES_COMMAND_OK)
-		pgfdw_report_error(res, fsstate->conn, sql);
-	PQclear(res);
+		/* Now force a fresh FETCH. */
+		fsstate->tuples = NULL;
+		fsstate->num_tuples = 0;
+		fsstate->next_tuple = 0;
+		fsstate->fetch_ct_2 = 0;
+		fsstate->eof_reached = false;
 
-	/* Now force a fresh FETCH. */
-	fsstate->tuples = NULL;
-	fsstate->num_tuples = 0;
-	fsstate->next_tuple = 0;
-	fsstate->fetch_ct_2 = 0;
-	fsstate->eof_reached = false;
+		clear_conn_state(fsstate->conn_state);
+	}
 }
 
 /*
@@ -3718,6 +3849,66 @@ ec_member_matches_foreign(PlannerInfo *root, RelOptInfo *rel,
 	return true;
 }
 
+static void
+populate_query_state(PrevQueryState * copy_to, PrevQueryState * pqs)
+{
+	copy_to->last_numParams = pqs->last_numParams;
+	copy_to->last_query = pqs->last_query;
+	copy_to->last_cursor_number = pqs->last_cursor_number;
+	copy_to->total_tuples = pqs->total_tuples;
+	copy_to->last_rel = pqs->last_rel;
+	copy_to->last_tupdesc = pqs->last_tupdesc;
+	copy_to->last_attinmeta = pqs->last_attinmeta;
+	copy_to->last_retrieved_attrs = pqs->last_retrieved_attrs;
+	copy_to->next = NULL;
+
+}
+static void
+save_prev_query(ForeignScanState *node)
+{
+	PgFdwScanState *fsstate = (PgFdwScanState *) node->fdw_state;
+	EState	   *estate = node->ss.ps.state;
+	MemoryContext oldcontext = CurrentMemoryContext;
+	PrevQueryState *pqs = (PrevQueryState *) palloc0(sizeof(PrevQueryState));
+	PrevQueryState *p1 = NULL,
+			   *new_pqs = NULL;
+
+	pqs->last_numParams = fsstate->numParams;
+	pqs->last_query = fsstate->query;
+	pqs->last_cursor_number = fsstate->cursor_number;
+	pqs->total_tuples = 0;
+	pqs->last_rel = fsstate->rel;
+	pqs->last_tupdesc = fsstate->tupdesc;
+	pqs->last_attinmeta = fsstate->attinmeta;
+	pqs->last_retrieved_attrs = fsstate->retrieved_attrs;
+	pqs->next = NULL;
+
+	if (fsstate->conn_state->num_prev_queries == 0)
+	{
+		fsstate->conn_state->prev_cxt = AllocSetContextCreate(estate->es_query_cxt,
+															  "prev_query context",
+															  ALLOCSET_DEFAULT_SIZES);
+		MemoryContextSwitchTo(fsstate->conn_state->prev_cxt);
+		fsstate->conn_state->prev_queries = (PrevQueryState *) palloc0(sizeof(PrevQueryState));
+		populate_query_state(fsstate->conn_state->prev_queries, pqs);
+	}
+	else
+	{
+		if (!fsstate->conn_state->prev_cxt)
+			elog(LOG, "No prev_query context exists");
+		MemoryContextSwitchTo(fsstate->conn_state->prev_cxt);
+		p1 = fsstate->conn_state->prev_queries;
+		for (; p1->next != NULL; p1 = p1->next);
+		/* get the last query in list */
+		new_pqs = (PrevQueryState *) palloc0(sizeof(PrevQueryState));
+		populate_query_state(new_pqs, pqs);
+		p1->next = new_pqs;
+	}
+	fsstate->conn_state->num_prev_queries++;
+	MemoryContextSwitchTo(oldcontext);
+	pfree(pqs);
+}
+
 /*
  * Create cursor for node's query with current parameter values.
  */
@@ -3730,7 +3921,7 @@ create_cursor(ForeignScanState *node)
 	const char **values = fsstate->param_values;
 	PGconn	   *conn = fsstate->conn;
 	StringInfoData buf;
-	PGresult   *res;
+	PGresult   *res = NULL;
 
 	/* First, process a pending asynchronous request, if any. */
 	if (fsstate->conn_state->pendingAreq)
@@ -3755,29 +3946,62 @@ create_cursor(ForeignScanState *node)
 		MemoryContextSwitchTo(oldcontext);
 	}
 
-	/* Construct the DECLARE CURSOR command */
-	initStringInfo(&buf);
-	appendStringInfo(&buf, "DECLARE c%u CURSOR FOR\n%s",
-					 fsstate->cursor_number, fsstate->query);
+	if (pgfdw_use_cursor)
+	{
+		/* Construct the DECLARE CURSOR command */
+		initStringInfo(&buf);
+		appendStringInfo(&buf, "DECLARE c%u CURSOR FOR\n%s",
+						 fsstate->cursor_number, fsstate->query);
 
-	/*
-	 * Notice that we pass NULL for paramTypes, thus forcing the remote server
-	 * to infer types for all parameters.  Since we explicitly cast every
-	 * parameter (see deparse.c), the "inference" is trivial and will produce
-	 * the desired result.  This allows us to avoid assuming that the remote
-	 * server has the same OIDs we do for the parameters' types.
-	 */
-	if (!PQsendQueryParams(conn, buf.data, numParams,
-						   NULL, values, NULL, NULL, 0))
-		pgfdw_report_error(NULL, conn, buf.data);
+		/*
+		 * Notice that we pass NULL for paramTypes, thus forcing the remote
+		 * server to infer types for all parameters.  Since we explicitly cast
+		 * every parameter (see deparse.c), the "inference" is trivial and
+		 * will produce the desired result.  This allows us to avoid assuming
+		 * that the remote server has the same OIDs we do for the parameters'
+		 * types.
+		 */
+		if (!PQsendQueryParams(conn, buf.data, numParams,
+							   NULL, values, NULL, NULL, 0))
+			pgfdw_report_error(NULL, conn, buf.data);
 
-	/*
-	 * Get the result, and check for success.
-	 */
-	res = pgfdw_get_result(conn);
-	if (PQresultStatus(res) != PGRES_COMMAND_OK)
-		pgfdw_report_error(res, conn, fsstate->query);
-	PQclear(res);
+		/*
+		 * Get the result, and check for success.
+		 */
+		res = pgfdw_get_result(conn);
+		if (PQresultStatus(res) != PGRES_COMMAND_OK)
+			pgfdw_report_error(res, conn, fsstate->query);
+		PQclear(res);
+	}
+	else
+	{
+		/* Setup to fetch without cursors */
+		if (fsstate->conn_state->num_prev_queries > 0)
+			fillTupleSlot(fsstate, node);
+
+		initStringInfo(&buf);
+		appendStringInfo(&buf, "%s", fsstate->query);
+
+		if (!PQsendQueryParams(conn, buf.data, numParams,
+							   NULL, values, NULL, NULL, 0))
+		{
+			clear_conn_state(fsstate->conn_state);
+			pgfdw_report_error(NULL, conn, buf.data);
+		}
+
+		/*
+		 * Call for Chunked rows mode with same size of chunk as the fetch
+		 * size
+		 */
+		if (!PQsetChunkedRowsMode(conn, fsstate->fetch_size))
+		{
+			clear_conn_state(fsstate->conn_state);
+			pgfdw_report_error(NULL, conn, buf.data);
+		}
+
+		/* We need to know if there are simultaneous queries running. */
+		save_prev_query(node);
+	}
 
 	/* Mark the cursor as created, and show no tuples have been retrieved */
 	fsstate->cursor_exists = true;
@@ -3795,14 +4019,18 @@ create_cursor(ForeignScanState *node)
  * Fetch some more rows from the node's cursor.
  */
 static void
-fetch_more_data(ForeignScanState *node)
+fetch_more_data(ForeignScanState *node, bool use_tts)
 {
 	PgFdwScanState *fsstate = (PgFdwScanState *) node->fdw_state;
 	PGconn	   *conn = fsstate->conn;
-	PGresult   *res;
-	int			numrows;
-	int			i;
+	PGresult   *res = NULL;
+	int			numrows = 0;
+	int			i = 0;
 	MemoryContext oldcontext;
+	bool		already_done = false;
+	HeapTuple	temp_tuple = NULL;
+	PrevQueryState *p1 = NULL,
+			   *cur_prev = NULL;
 
 	/*
 	 * We'll store the tuples in the batch_cxt.  First, flush the previous
@@ -3828,7 +4056,7 @@ fetch_more_data(ForeignScanState *node)
 		/* Reset per-connection state */
 		fsstate->conn_state->pendingAreq = NULL;
 	}
-	else
+	else if (pgfdw_use_cursor)
 	{
 		char		sql[64];
 
@@ -3841,24 +4069,186 @@ fetch_more_data(ForeignScanState *node)
 		if (PQresultStatus(res) != PGRES_TUPLES_OK)
 			pgfdw_report_error(res, conn, fsstate->query);
 	}
+	else
+	{
+		if (!fsstate->conn_state->prev_cxt)
+			elog(LOG, "No prev_query context exists");
+		MemoryContextSwitchTo(fsstate->conn_state->prev_cxt);
+		/* Retrieve the tuples from the TupleSlot instead of actual fetch */
+		p1 = fsstate->conn_state->prev_queries;
 
-	/* Convert the data into HeapTuples */
-	numrows = PQntuples(res);
-	fsstate->tuples = (HeapTuple *) palloc0(numrows * sizeof(HeapTuple));
-	fsstate->num_tuples = numrows;
-	fsstate->next_tuple = 0;
+		for (; p1->next != NULL; p1 = p1->next)
+			/* find the correct prev_query */
+		{
+			if ((p1->tuples_ready && fsstate->cursor_number == p1->last_cursor_number))
+				cur_prev = p1;
+		}
+
+		if (cur_prev)
+		{
+			already_done = true;
+			numrows = cur_prev->total_tuples;
+			fsstate->tuples = (HeapTuple *) palloc0(numrows * sizeof(HeapTuple));
+			fsstate->num_tuples = numrows;
+			fsstate->next_tuple = 0;
+
+			while (tuplestore_gettupleslot(cur_prev->tuplestore, true, true, cur_prev->slot))
+			{
+				fsstate->tuples[i++] = ExecFetchSlotHeapTuple(cur_prev->slot, true, NULL);
+				ExecClearTuple(cur_prev->slot);
+				if (i > numrows)
+					elog(ERROR, "more rows to store than received %d", i);
+			}
 
-	for (i = 0; i < numrows; i++)
+			fsstate->eof_reached = true;
+			/* Clear the last query details, once tuples are retrieved. */
+			if (fsstate->conn_state->prev_queries == cur_prev)
+			{
+				/*
+				 * This is the first prev query in the list, check if there
+				 * are more
+				 */
+				if (fsstate->conn_state->num_prev_queries > 1)
+					fsstate->conn_state->prev_queries->next = cur_prev->next;
+				clear_prev_query_state(cur_prev);
+			}
+			MemoryContextSwitchTo(oldcontext);
+			return;
+		}
+		else
+		{
+			/*
+			 * Non-cursor mode uses PQSetChunkedRowsMode during create_cursor,
+			 * so just get the result here.
+			 */
+			res = pgfdw_get_next_result(conn);
+			if (PQresultStatus(res) == PGRES_FATAL_ERROR)
+			{
+				clear_conn_state(fsstate->conn_state);
+				pgfdw_report_error(res, conn, fsstate->query);
+			}
+			else if (PQresultStatus(res) == PGRES_TUPLES_OK)
+			{
+				/*
+				 * This signifies query is completed and there are no more
+				 * tuples left.
+				 */
+				if (use_tts)
+				{
+					/*
+					 * This only happens when we are coming from
+					 * fillTupleSlot, so in that case we need not to release
+					 * tupleDesc, because we would need it later.
+					 */
+					already_done = true;
+				}
+				else
+				{
+					p1 = fsstate->conn_state->prev_queries;
+					for (; p1 != NULL; p1 = p1->next)
+					{
+						if (p1->tuplestore && p1->last_tupdesc)
+						{
+							ReleaseTupleDesc(p1->last_tupdesc);
+							p1->last_tupdesc = NULL;
+						}
+					}
+				}
+				fsstate->eof_reached = true;
+				while (res != NULL)
+					res = pgfdw_get_result(conn);
+			}
+			else if (PQresultStatus(res) == PGRES_TUPLES_CHUNK)
+			{
+				if (use_tts)
+				{
+					temp_tuple = (HeapTuple) palloc0(sizeof(HeapTuple));
+					p1 = fsstate->conn_state->prev_queries;
+
+					/* Always fetch the last prev_query */
+					for (; p1->next != NULL; p1 = p1->next);
+
+					/*
+					 * This is to fetch all the tuples of this query and save
+					 * them in Tuple Slot. Since it is using
+					 * PQSetChunkedRowsMode, we only get the
+					 * fsstate->fetch_size tuples in one run, so keep on
+					 * executing till we get NULL in PGresult i.e. all the
+					 * tuples are retrieved.
+					 */
+					p1->tuplestore = tuplestore_begin_heap(false, true, work_mem);
+					p1->slot = MakeSingleTupleTableSlot(fsstate->tupdesc, &TTSOpsMinimalTuple);
+
+					i = 0;
+					for (;;)
+					{
+						CHECK_FOR_INTERRUPTS();
+						numrows = PQntuples(res);
+
+						/* Convert the data into HeapTuples */
+						Assert(IsA(node->ss.ps.plan, ForeignScan));
+						for (i = 0; i < numrows; i++)
+						{
+							temp_tuple = make_tuple_from_result_row(res, i,
+																	fsstate->rel,
+																	fsstate->attinmeta,
+																	fsstate->retrieved_attrs,
+																	node,
+																	fsstate->temp_cxt);
+							tuplestore_puttuple(p1->tuplestore, temp_tuple);
+							p1->total_tuples++;
+						}
+						pfree(temp_tuple);
+
+						res = pgfdw_get_next_result(conn);
+						if (res == NULL)
+							break;
+
+						else if (PQresultStatus(res) == PGRES_TUPLES_OK)
+						{
+							while (res != NULL)
+								res = pgfdw_get_result(conn);
+							break;
+						}
+						else if (PQresultStatus(res) == PGRES_FATAL_ERROR)
+						{
+							clear_conn_state(fsstate->conn_state);
+							pgfdw_report_error(res, conn, fsstate->query);
+						}
+
+					}
+					MemoryContextSwitchTo(fsstate->batch_cxt);
+
+					/*
+					 * EOF is reached because when we are storing all tuples
+					 * to the tuplestore.
+					 */
+					fsstate->eof_reached = true;
+					already_done = true;
+				}
+			}
+		}
+	}
+	if (!already_done)
 	{
-		Assert(IsA(node->ss.ps.plan, ForeignScan));
+		/* Convert the data into HeapTuples */
+		numrows = PQntuples(res);
+		fsstate->tuples = (HeapTuple *) palloc0(numrows * sizeof(HeapTuple));
+		fsstate->num_tuples = numrows;
+		fsstate->next_tuple = 0;
 
-		fsstate->tuples[i] =
-			make_tuple_from_result_row(res, i,
-									   fsstate->rel,
-									   fsstate->attinmeta,
-									   fsstate->retrieved_attrs,
-									   node,
-									   fsstate->temp_cxt);
+		for (i = 0; i < numrows; i++)
+		{
+			Assert(IsA(node->ss.ps.plan, ForeignScan));
+
+			fsstate->tuples[i] =
+				make_tuple_from_result_row(res, i,
+										   fsstate->rel,
+										   fsstate->attinmeta,
+										   fsstate->retrieved_attrs,
+										   node,
+										   fsstate->temp_cxt);
+		}
 	}
 
 	/* Update fetch_ct_2 */
@@ -3941,11 +4331,19 @@ close_cursor(PGconn *conn, unsigned int cursor_number,
 	char		sql[64];
 	PGresult   *res;
 
-	snprintf(sql, sizeof(sql), "CLOSE c%u", cursor_number);
-	res = pgfdw_exec_query(conn, sql, conn_state);
-	if (PQresultStatus(res) != PGRES_COMMAND_OK)
-		pgfdw_report_error(res, conn, sql);
-	PQclear(res);
+	if (pgfdw_use_cursor)
+	{
+		snprintf(sql, sizeof(sql), "CLOSE c%u", cursor_number);
+		res = pgfdw_exec_query(conn, sql, conn_state);
+		if (PQresultStatus(res) != PGRES_COMMAND_OK)
+			pgfdw_report_error(res, conn, sql);
+		PQclear(res);
+	}
+	else
+	{
+		while (pgfdw_get_result(conn) != NULL);
+		clear_conn_state(conn_state);
+	}
 }
 
 /*
@@ -5239,7 +5637,7 @@ postgresAcquireSampleRowsFunc(Relation relation, int elevel,
 	for (;;)
 	{
 		int			numrows;
-		int			i;
+		int			i = 0;
 
 		/* Allow users to cancel long query */
 		CHECK_FOR_INTERRUPTS();
@@ -5306,7 +5704,7 @@ static void
 analyze_row_processor(PGresult *res, int row, PgFdwAnalyzeState *astate)
 {
 	int			targrows = astate->targrows;
-	int			pos;			/* array index to store tuple in */
+	int			pos = 0;		/* array index to store tuple in */
 	MemoryContext oldcontext;
 
 	/* Always increment sample row counter. */
@@ -5338,7 +5736,7 @@ analyze_row_processor(PGresult *res, int row, PgFdwAnalyzeState *astate)
 			Assert(pos >= 0 && pos < targrows);
 			heap_freetuple(astate->rows[pos]);
 		}
-		else
+		else if (pgfdw_use_cursor)
 		{
 			/* Skip this tuple. */
 			pos = -1;
@@ -7314,7 +7712,7 @@ postgresForeignAsyncNotify(AsyncRequest *areq)
 	if (!PQconsumeInput(fsstate->conn))
 		pgfdw_report_error(NULL, fsstate->conn, fsstate->query);
 
-	fetch_more_data(node);
+	fetch_more_data(node, false);
 
 	produce_tuple_asynchronously(areq, true);
 }
@@ -7400,6 +7798,13 @@ fetch_more_data_begin(AsyncRequest *areq)
 	PgFdwScanState *fsstate = (PgFdwScanState *) node->fdw_state;
 	char		sql[64];
 
+	/*
+	 * Reset cursor mode when in asynchronous mode as it is not supported in
+	 * non-cursor mode
+	 */
+	if (!pgfdw_use_cursor)
+		pgfdw_use_cursor = true;
+
 	Assert(!fsstate->conn_state->pendingAreq);
 
 	/* Create the cursor synchronously. */
@@ -7432,7 +7837,7 @@ process_pending_request(AsyncRequest *areq)
 	/* The request should be currently in-process */
 	Assert(fsstate->conn_state->pendingAreq == areq);
 
-	fetch_more_data(node);
+	fetch_more_data(node, false);
 
 	/*
 	 * If we didn't get any tuples, must be end of data; complete the request
diff --git a/contrib/postgres_fdw/postgres_fdw.h b/contrib/postgres_fdw/postgres_fdw.h
index e69735298d7..892aced8d00 100644
--- a/contrib/postgres_fdw/postgres_fdw.h
+++ b/contrib/postgres_fdw/postgres_fdw.h
@@ -16,9 +16,11 @@
 #include "foreign/foreign.h"
 #include "lib/stringinfo.h"
 #include "libpq/libpq-be-fe.h"
+#include "libpq-int.h"
 #include "nodes/execnodes.h"
 #include "nodes/pathnodes.h"
 #include "utils/relcache.h"
+#include "funcapi.h"
 
 /*
  * FDW-specific planner information kept in RelOptInfo.fdw_private for a
@@ -131,12 +133,34 @@ typedef struct PgFdwRelationInfo
 	int			relation_index;
 } PgFdwRelationInfo;
 
+/* Info about the last query to be used in non-cursor mode only */
+typedef struct PrevQueryState
+{
+	Relation	last_rel;
+	AttInMetadata *last_attinmeta;
+	char	   *last_query;
+	List	   *last_retrieved_attrs;
+	int			last_numParams;
+	TupleDesc	last_tupdesc;
+	Tuplestorestate *tuplestore;
+	TupleTableSlot *slot;
+	bool		tuples_ready;
+	int			last_cursor_number;
+	int			total_tuples;
+
+	struct PrevQueryState *next;
+}			PrevQueryState;
+
 /*
  * Extra control information relating to a connection.
  */
 typedef struct PgFdwConnState
 {
 	AsyncRequest *pendingAreq;	/* pending async request */
+	/* Info about the last query to be used in non-cursor mode only */
+	int			num_prev_queries;
+	MemoryContext prev_cxt;
+	PrevQueryState *prev_queries;
 } PgFdwConnState;
 
 /*
@@ -164,6 +188,7 @@ extern unsigned int GetCursorNumber(PGconn *conn);
 extern unsigned int GetPrepStmtNumber(PGconn *conn);
 extern void do_sql_command(PGconn *conn, const char *sql);
 extern PGresult *pgfdw_get_result(PGconn *conn);
+extern PGresult *pgfdw_get_next_result(PGconn *conn);
 extern PGresult *pgfdw_exec_query(PGconn *conn, const char *query,
 								  PgFdwConnState *state);
 pg_noreturn extern void pgfdw_report_error(PGresult *res, PGconn *conn,
@@ -179,6 +204,7 @@ extern List *ExtractExtensionList(const char *extensionsString,
 								  bool warnOnMissing);
 extern char *process_pgfdw_appname(const char *appname);
 extern char *pgfdw_application_name;
+extern bool pgfdw_use_cursor;
 
 /* in deparse.c */
 extern void classifyConditions(PlannerInfo *root,
